#include <stdlib.h>
#include <memory.h>
#include <gostr2c.h>
#include <_cgo_export.h>

char* GoString2CStr(void* p, char* buffer, int cb)
{
  GoString* goString = (GoString*)p;
  if (!goString || !goString->n)
    return 0;

  if (goString->n < cb - 1)
  {
    memcpy(buffer, goString->p, goString->n);
    buffer[goString->n] = '\0';
    return buffer;
  }

  char* s = malloc(goString->n + 1);
  if (!s)
    return 0;

  memcpy(s, goString->p, goString->n);
  s[goString->n] = '\0';
  
  return s;
}

void FreeCStr(char* s, char* buffer)
{
  if (!s || s == buffer)
    return;

  free(s);
}
